<#
.SYNOPSIS 
    This sample automation runbook is designed to be used in a watcher task that takes action
    on data passed in from a watcher runbook.

.DESCRIPTION
    This sample automation runbook is designed to be used in a watcher task that takes action
    on data passed in from a watcher runbook. It is required to have a parameter called $EVENTDATA in
    watcher action runbooks to receive information from the watcher runbook.

.PARAMETER EVENTDATA
    Optional. Contains the information passed in from the watcher runbook.

.NOTES
    AUTHOR: Automation Team
    LASTEDIT: Nov 12th, 2017
#>

param(
    $EVENTDATA
)

Write-Output("Message is " + $EVENTDATA.EventProperties.Message)
Write-Output("Passed in data is " + ($EVENTDATA.EventProperties.Data | ConvertFrom-Json))
$Details = $EVENTDATA.EventProperties.Data |ConvertFrom-Json
$WName = $EVENTDATA.EventProperties.WatcherName

# Read all lines of the file and add a NewLine afterwards
$Filelines = $details.content.value|foreach-object {$_ + "`n"}
Import-Module Provance.Dyn365,Provance.Azure

# Generate raise time date value
$raiseTime = Get-Date -date $eventdata.eventproperties.TimeStamp

#Create Provance ITSM Event Data
$Eventbody = @{
    'apitil_name'            = "Hybrid Watcher Event $WName on Oglaroon"
    'apitil_raisedon'        = $raisetime
    'apitil_description'     = "$($Details.filename) contains `n " + "$Filelines"
    'apitil_eventidexternal' = $eventdata.invocationid
    'apitil_keyword'         = '345550002'
    'apitil_source'          = '100000000'
    'apitil_device'          = 'OGLAROON'
    'apitil_sourcestate'     = '345550005'
    'apitil_sourcepriority'  = '345550000'
    'apitil_platform'        = '345550000'
    'apitil_level'           = '345550001'
}
# Connecting to ITSM 9000 Instance
$cred = Get-AutomationPSCredential -Name 'TheNameofAStoredCredentialInAzureAutomation'
$itsmtokenbody = @{
    UserCredential = $cred
    TenantId       = '00000000-0000-0000-0000-000000000000'
    Resource       = 'https://yourcrminstancename.crm11.dynamics.com/'
}
$ITSMToken = Get-ProvAzureAuthContext @itsmtokenbody

# Create Event   
New-ProvDyn365Entity -AuthContext $ITSMToken -EntityName 'apitil_event' -Body $Eventbody


